<script setup lang="ts">
    import { ref } from "vue";
    import { error } from "../plugins/toast";
    import useImportStore from "./../stores/import";
    import HashReattachmentSystem from "./RegisterCards/HashReattachmentSystem.vue";
    import { useRouter } from "vue-router";
    import { StaticRoutePaths } from "../plugins/router";

    const router = useRouter();
    const importStore = useImportStore();

    const dragover = ref(false);
    const FILE_EXT = ".mz.json";

    function addDropFile(e: DragEvent) {
        const transfer = e.dataTransfer;
        if (transfer != null) {
            handleFile(transfer.files[0]);
        }
    }
    function handleUploadUsage(e: Event) {
        const target = e.target;
        if (target != null) {
            const files = (target as any).files;
            if (files && files != undefined && files != null && files.length > 0) {
                handleFile(files[0]);
            }
        }
    }
    async function handleFile(f: File) {
        const name = f.name;

        if (!name.endsWith(FILE_EXT)) {
            error(`Bitt nur '*${FILE_EXT}' Dateien hochladen.`);
        } else {
            // process file
            importStore.setInput(await f.text());
        }
    }
</script>

<template>
    <div class="pa-3">
        <h2 class="text-center">Import Interface</h2>

        <HashReattachmentSystem
            v-if="importStore.importedStructure != null"
            :birth-date="importStore.birthDate"
            :call-name="importStore.callName != '' ? importStore.callName : importStore.givenName.split(' ')[0]"
            :family-name="importStore.familyName"
            :given-name="importStore.givenName"
        ></HashReattachmentSystem>

        <div
            :class="{ drag_border: dragover }"
            @drop.prevent="
                (e) => {
                    e.preventDefault();
                    dragover = false;
                    addDropFile(e);
                }
            "
            @dragover.prevent="
                (e) => {
                    e.preventDefault();
                    dragover = true;
                }
            "
            @dragenter.prevent="dragover = true"
            @dragleave.prevent="dragover = false"
        >
            <v-card title="Datei hochladen" variant="tonal" class="my-2">
                <template v-slot:text>
                    Kann auch per Drag-And-Drop aut diese Kachel gezogen werden
                    <br />
                    <br />
                    <v-file-input label="File input" :accept="FILE_EXT" @change="handleUploadUsage"></v-file-input>
                </template>
            </v-card>
        </div>

        <v-card title="Import verarbeiten" variant="tonal" class="my-2" v-if="importStore.importedStructure != null">
            <template v-slot:text>
                <v-row class="ma-4">
                    <v-btn class="v-col-12" @click="importStore.clearInput()">
                        <template v-slot:prepend> <span class="material-symbols-outlined"> delete_forever </span></template>
                        Eingabehilfe leeren
                    </v-btn>
                </v-row>
                <v-row class="ma-4">
                    <v-btn class="v-col-12" @click="router.push({ name: StaticRoutePaths.CreateParticipant })">
                        <template v-slot:prepend> <span class="material-symbols-outlined"> person_add </span></template>
                        Direkt erstellen
                    </v-btn>
                </v-row>
                <pre class="ml-4">{{ importStore.importedStructure }}</pre>
            </template>
        </v-card>
    </div>
</template>

<style scoped>
    .drag_border {
        border: 5px grey solid;
    }
</style>
